
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] MTIInstall] >= 0 } {
    interp expose {} MTIInstall
}

proc ::MTIInstall { name } {
    foreach rqst { "Init" "Config" "Reset" "Log" "StopLog" "GetConfiguration" "AverageSamples" "SetBiases" "GetBiases" "MTI_INFOsensorDataPosterRead" "SEPosposPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} MTI$rqst $name
    }
}

interp hide {} MTIInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] MTIInit] >= 0 } {
    interp expose {} MTIInit
}
if { [lsearch [interp hidden] MTIInitFormatOutput] >= 0 } {
    interp expose {} MTIInitFormatOutput
}

proc ::MTIInit { name args } {
    set format {}
    lappend format [list string "Serial port" "/dev/ttyS0" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Open a connection on MTI and configure it with default values" \
	"INERTIAL_DEVICE\n| char device\[24\]\n" \
	1 \
	$format \
	$args ]
}


proc ::MTIInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIInit
interp hide {} MTIInitFormatOutput





# Config ----------------------------------------------------------

if { [lsearch [interp hidden] MTIConfig] >= 0 } {
    interp expose {} MTIConfig
}
if { [lsearch [interp hidden] MTIConfigFormatOutput] >= 0 } {
    interp expose {} MTIConfigFormatOutput
}

proc ::MTIConfig { name args } {
    set format {}
    lappend format [list { "MTI_OPMODE_BOTH" "MTI_OPMODE_ORIENTATION" "MTI_OPMODE_CALIBRATED" } "Output mode" "MTI_OPMODE_BOTH" ]
    lappend format [list { "MTI_OPFORMAT_MAT" "MTI_OPFORMAT_EULER" "MTI_OPFORMAT_QUAT" } "Orient. format" "MTI_OPFORMAT_MAT" ]
    lappend format [list { "MTI_SYNCOUTMODE_PULSE" "MTI_SYNCOUTMODE_TOGGLE" "MTI_SYNCOUTMODE_DISABLED" } "SyncOut mode" "MTI_SYNCOUTMODE_PULSE" ]
    lappend format [list { "MTI_SYNCOUTPULSE_POS" "MTI_SYNCOUTPULSE_NEG" } "SyncOut pulse polarity" "MTI_SYNCOUTPULSE_POS" ]
    lappend format [list int "SyncOut skip factor (nbr of skipped syncOuts)" "0" ]
    lappend format [list int "SyncOut Offset (in 33.9ns units)" "0" ]
    lappend format [list int "SyncOut puylse width (in 33.9ns units, default is 5ms)" "147493" ]

    return [ ::cs::rqstSend "${name}" "Config" \
	"Configure MTI" \
	"INERTIAL_CONFIG\n| OutputMode outputMode\n| OutputFormat outputFormat\n| SyncOutMode syncOutMode\n| SyncOutPulsePolarity syncOutPulsePolarity\n| int syncOutSkipFactor\n| int syncOutOffset\n| int syncOutPulseWidth\n" \
	7 \
	$format \
	$args ]
}


proc ::MTIConfigFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIConfig
interp hide {} MTIConfigFormatOutput





# Reset ----------------------------------------------------------

if { [lsearch [interp hidden] MTIReset] >= 0 } {
    interp expose {} MTIReset
}
if { [lsearch [interp hidden] MTIResetFormatOutput] >= 0 } {
    interp expose {} MTIResetFormatOutput
}

proc ::MTIReset { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Reset" \
	"Send a reset to the MTI" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MTIResetFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIReset
interp hide {} MTIResetFormatOutput





# Log ----------------------------------------------------------

if { [lsearch [interp hidden] MTILog] >= 0 } {
    interp expose {} MTILog
}
if { [lsearch [interp hidden] MTILogFormatOutput] >= 0 } {
    interp expose {} MTILogFormatOutput
}

proc ::MTILog { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Log" \
	"Log MTI data" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::MTILogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTILog
interp hide {} MTILogFormatOutput





# StopLog ----------------------------------------------------------

if { [lsearch [interp hidden] MTIStopLog] >= 0 } {
    interp expose {} MTIStopLog
}
if { [lsearch [interp hidden] MTIStopLogFormatOutput] >= 0 } {
    interp expose {} MTIStopLogFormatOutput
}

proc ::MTIStopLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLog" \
	"Stop Logging data" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MTIStopLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIStopLog
interp hide {} MTIStopLogFormatOutput





# GetConfiguration ----------------------------------------------------------

if { [lsearch [interp hidden] MTIGetConfiguration] >= 0 } {
    interp expose {} MTIGetConfiguration
}
if { [lsearch [interp hidden] MTIGetConfigurationFormatOutput] >= 0 } {
    interp expose {} MTIGetConfigurationFormatOutput
}

proc ::MTIGetConfiguration { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetConfiguration" \
	"Get current intertial configuration" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MTIGetConfigurationFormatOutput { list } {
    set format { {} status { } { config { } outputMode { } outputFormat { } syncOutMode { } syncOutPulsePolarity { } syncOutSkipFactor { } syncOutOffset { } syncOutPulseWidth } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIGetConfiguration
interp hide {} MTIGetConfigurationFormatOutput





# AverageSamples ----------------------------------------------------------

if { [lsearch [interp hidden] MTIAverageSamples] >= 0 } {
    interp expose {} MTIAverageSamples
}
if { [lsearch [interp hidden] MTIAverageSamplesFormatOutput] >= 0 } {
    interp expose {} MTIAverageSamplesFormatOutput
}

proc ::MTIAverageSamples { name args } {
    set format {}
    lappend format [list int "Nb of samples to compute the averages" "1000" ]

    return [ ::cs::rqstSend "${name}" "AverageSamples" \
	"Computes the mean and standard deviation of the pitch and roll angles" \
	"AVERAGING_PARAMETERS\n| int nbSamples\n" \
	1 \
	$format \
	$args ]
}


proc ::MTIAverageSamplesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIAverageSamples
interp hide {} MTIAverageSamplesFormatOutput





# SetBiases ----------------------------------------------------------

if { [lsearch [interp hidden] MTISetBiases] >= 0 } {
    interp expose {} MTISetBiases
}
if { [lsearch [interp hidden] MTISetBiasesFormatOutput] >= 0 } {
    interp expose {} MTISetBiasesFormatOutput
}

proc ::MTISetBiases { name args } {
    set format {}
    lappend format [list double "Bias on the pitch angle (in degrees)" "0.0" ]
    lappend format [list double "Bias on the roll angle (in degrees)" "0.0" ]

    return [ ::cs::rqstSend "${name}" "SetBiases" \
	"Set the biases on the roll and pitch angles" \
	"MTI_BIASES\n| double pitchBias\n| double rollBias\n" \
	2 \
	$format \
	$args ]
}


proc ::MTISetBiasesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTISetBiases
interp hide {} MTISetBiasesFormatOutput





# GetBiases ----------------------------------------------------------

if { [lsearch [interp hidden] MTIGetBiases] >= 0 } {
    interp expose {} MTIGetBiases
}
if { [lsearch [interp hidden] MTIGetBiasesFormatOutput] >= 0 } {
    interp expose {} MTIGetBiasesFormatOutput
}

proc ::MTIGetBiases { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetBiases" \
	"Get the  biases on the roll and pitch angles" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MTIGetBiasesFormatOutput { list } {
    set format { {} status { } { biases { } pitchBias { } rollBias } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIGetBiases
interp hide {} MTIGetBiasesFormatOutput





# MTI_INFOsensorData ----------------------------------------------------------

if { [lsearch [interp hidden] MTIMTI_INFOsensorDataPosterRead] >= 0 } {
    interp expose {} MTIMTI_INFOsensorDataPosterRead
}
if { [lsearch [interp hidden] MTIMTI_INFOsensorDataPosterFormatOutput] >= 0 } {
    interp expose {} MTIMTI_INFOsensorDataPosterFormatOutput
}

proc ::MTIMTI_INFOsensorDataPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MTI_INFOsensorData" \
	"INERTIAL_DATA\n| float ACC\[3\]\n| float GYR\[3\]\n| float MAG\[3\]\n| float EULER\[3\]\n| int COUNT\n| double TIMESTAMP\n| double TIMESTAMP_RAW\n| double TIMESTAMP_UNDELAYED\n| double TIMESTAMP_FILTERED\n" \
	$args ]
}


proc ::MTIMTI_INFOsensorDataPosterFormatOutput { list } {
    set format { {} status { } { sensorData { 3 } ACC { 3 } GYR { 3 } MAG { 3 } EULER { } COUNT { } TIMESTAMP { } TIMESTAMP_RAW { } TIMESTAMP_UNDELAYED { } TIMESTAMP_FILTERED } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTIMTI_INFOsensorDataPosterRead
interp hide {} MTIMTI_INFOsensorDataPosterFormatOutput





# SEPospos ----------------------------------------------------------

if { [lsearch [interp hidden] MTISEPosposPosterRead] >= 0 } {
    interp expose {} MTISEPosposPosterRead
}
if { [lsearch [interp hidden] MTISEPosposPosterFormatOutput] >= 0 } {
    interp expose {} MTISEPosposPosterFormatOutput
}

proc ::MTISEPosposPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SEPospos" \
	"POM_SENSOR_POS\n| int date\n| int pad\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::MTISEPosposPosterFormatOutput { list } {
    set format { {} status { } { pos { } date { } pad { } { sensorToMain { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToBase { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToOrigin { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MTISEPosposPosterRead
interp hide {} MTISEPosposPosterFormatOutput


